#if !defined(__UTILITY_H)
#define __UTILITY_H

class Font;
class Texture;

const int MAX_INTEGER = 0x7FFFFFFF;
const int MIN_INTEGER = 0x80000000;

#define OS_9X   0x0001
#define OS_NT   0x0002
#define OS_95   0x0004
#define OS_98   0x0008
#define OS_ME   0x0010
#define OS_NT4  0x0020
#define OS_2K   0x0040
#define OS_XP   0x0080
#define OS_2KXP 0x0100

struct NameValuePair
{
	const char *name;
	int value;
};

HWND GetLitestepDesktop();

bool IsOS(const int &os);

void ModifyStyle(HWND hWnd, DWORD removeStyle, DWORD addStyle);

bool GetxRCBool(const string &prefix, const string &baseName, bool defaultVal = false);
int GetxRCInt(const string &prefix, const string &baseName, int defaultVal, int minVal = MIN_INTEGER, int maxVal = MAX_INTEGER);
string GetxRCString(const string &prefix, const string &baseName, const string &defaultVal);
string GetxRCLine(const string &prefix, const string &baseName, const string &defaultVal);
int GetxRCNamedValue(const string &prefix, const string &baseName, const NameValuePair *nameValuePairs, int defaultVal);

StringList GetxRCLineList(const string &prefix);

int GetxRCColor(const string &prefix, const string &baseName, int defaultVal);
Font *GetRCFont(const string &prefix);
Texture *GetDesktopTexture(const string path, const string name);

void PaintDesktopEx(HDC hdcDest, int xDest, int yDest, int cxDest, int cyDest, int xSrc, int ySrc, BOOL updateCache);
void TileBlt(HDC hdcDest, int xDest, int yDest, int cxDest, int cyDest, HDC hdcSrc, int xSrc, int ySrc, int cxSrc, int cySrc, DWORD rasterOp);

LPTSTR RegQueryStringValue(HKEY hKey, LPCTSTR pszSubKey, LPCTSTR pszValueName, LPTSTR pszBuffer, int nBufferSize, LPTSTR pszDefaultValue);

string IntToString(int input);

#endif
